# SOHO Radius für One-Time-Passw&ouml;rter selbstgebaut - Vortrag Chemnitzer Linux Tage 2019

## Kommando Pastie

### Folie 4 A: Betriebssystem

```
yum -y install epel-release
```

### Folie 5 B: Installation benoetigter Pakete

```
yum -y install oathtool pam_oath google-authenticator freeradius freeradius-utils freeradius-doc bc qrencode
yum -y install setroubleshoot-server wget vim net-tools
```

### Folie 6 C: Ordnerstruktur fuer OTPs anlegen

```
# oath-toolkit
 mkdir -p /var/tokens/oathtoolkit/
 touch /var/tokens/oathtoolkit/users.oath
 chown -R radiusd:radiusd /var/tokens/oathtoolkit/
 chmod 600 /var/tokens/oathtoolkit/users.oath
# libpam-google-authenticator
 mkdir -p /var/tokens/google/disabled/
 chown -R radiusd:radiusd /var/tokens/google/
# SELinux Fixes
 semanage fcontext -a -e /var/lib/radiusd /var/tokens
 restorecon -R -v /var/tokens/
```

### Folie 7 D: FreeRADIUS Modules - PAM aktivieren

```
# pam per symlink aktivieren
 ln -s /etc/raddb/mods-available/pam /etc/raddb/mods-enabled/pam
# Radius Konfigurationsdateien pruefen
 radiusd -fC && echo "Konfigurationsdateien ok"
```
### Folie 8 E: FreeRADIUS - Neue Site anlegen!

```
# neue site optsite.conf anlegen
 cp -p --preserve=context /etc/raddb/sites-available/default /etc/raddb/sites-available/otpsite.conf
# aktuellen Wert anzeigen
 grep -B 3 "pam" /etc/raddb/sites-available/otpsite.conf
# per search&replace Kommentar for #pam entfernen uns somit aktivieren
 sed -i 's|#\(.*pam\)$|\1|g' /etc/raddb/sites-available/otpsite.conf
# nochmal prüKommentar ist jetzt weg)
 grep -B 3 "pam" /etc/raddb/sites-available/otpsite.conf
```

### Folie 9 F: FreeRADIUS Site "Default" deaktivieren - optsite.conf aktivieren

```
# Site default loeschen
 rm -f /etc/raddb/sites-enabled/default # löt nur den Link zu '/etc/raddb/sites-available/default'
# Site otpsite.conf durch Erzeugen eines Symlinks aktivieren
 ln -s /etc/raddb/sites-available/otpsite.conf /etc/raddb/sites-enabled/otpsite.conf
# Konfigurationstest
 radiusd -fC && echo "Konfigurationsdateien ok"
```

### Folie 10 G: PAM Autentisierungsschnittstelle zu FreeRADIUS konfigurieren

```
# Backup /etc/pam.d/radiusd
 cp -p --preserve=context /etc/pam.d/radiusd /etc/pam.d/radiusd.bak
```
#### /etc/pam.d/radiusd

```
#%PAM-1.0
#
# /etc/pam.d/radiusd - PAM configuration for FreeRADIUS
#
# This is needed - do not try previous stacked module's password
account required /usr/lib64/security/pam_permit.so skip_first_pass

# libpam-oath
auth    optional /usr/lib64/security/pam_oath.so \
        usersfile=/var/tokens/oathtoolkit/users.oath \
        digits=6 \
        window=10

# libpam-google-authenticator
auth optional /usr/lib64/security/pam_google_authenticator.so \
     user=radiusd \
     secret=/var/tokens/google/${USER} \
     allowed_perm=0770 \
     no_strict_owner
```

### Folie 11 H: FreeRADIUS - Default Auth-Type auf PAM setzen

```
# Hint: /etc/raddb/users is a symlink to /etc/raddb/mods-config/files/authorize
 cp -p --preserve=context /etc/raddb/mods-config/files/authorize /etc/raddb/mods-config/files/authorize.bak
```

#### Pam als Default in /etc/raddb/mods-config/files/authorize setzen

```
...
...
#
# PAM Authentication for all (DEFAULT) users
#
# libpam-oath
DEFAULT Auth-Type := PAM
#########################################################
# You should add test accounts to the TOP of this file! #
# See the example user "bob" above.                     #
#########################################################
```

### Folie 12 I: FreeRADIUS Clients - Default Passwoerter aendern

```
# testing123 nach masterblaster2018 (kommt 2x !aktiv! vor)
 sed -i 's|^\(\s.*=\s\)testing123|\1masterblaster2018|g' /etc/raddb/clients.conf
```

### Folie 13 J: Template fuer "users.oath" erstellen

#### /var/tokens/oathtoolkit/users.oath

```
##############################################################################
### Um das spaetere Bearbeiten der Datei durch Skripte zu vereinfachen
### ist folgender Syntax festgelegt
###
### Kommentarzeilen haben 3 ### am Anfang
### eingepflegte aber nicht aktive Token beginnen mit ###NEW###<TOKENZEILE>
### schon einmal aktivierte aber im Moment deaktivierte Token beginnen mit ##
###
### Tokenzeilen haben folgenden Aufbau:
###
### HOTP event-based token with 6 digit OTP and prefix 1234
###  <TYP><TAB><USER/TOKENNAME><TAB><PREFIX><SECRETBASE32><COUNTER><LAST USED PIN><YYYY-MM-DDTH>H<:MM:SS>L
###  ##NEW##HOTP/E/6   U000001 1234    B39ACB389F70F169F60EBA9A76320569F0D78E82        0
###  HOTP/E/6          U000001 1234    9974CF573F278BB477F542DC8E5EBBD706C3D2E0        1    093436  2018-11-19T10:30:13L
###
### Siehe auch:
###  /usr/share/doc/pam_oath-<version>/README
###  https://code.google.com/archive/p/mod-authn-otp/wikis/UsersFile.wiki
##############################################################################
```

### Folie 14 K: FreeRADIUS starten und Autostart aktivieren

```
 systemctl start radiusd
 systemctl status radiusd
 systemctl enable radiusd
```

### Folie 15 L: Testtoken pam_google g0001

```
# erzeugt /var/tokens/google/g0001 mit 10 Emergency Scratchcodes
# wir nutzen pam_google nur fuer Scratchcodes in unserem Setup!
# muss als Benutzer radiusd ausgefuehrt werden
 su -s /bin/bash -c 'google-authenticator -c -f -Q NONE -r 3 -R 30 -s /var/tokens/google/g0001 -w 3 -e 10' radiusd
# nun einen der Scratchcodes kopieren und dann in folgenden Befehl einsetzen um zu pruefen, dass er funktioniert
# z.B. 76005208
 radtest g0001 76005208 127.0.0.1 18120 masterblaster2018
# der benutzte Emergency Scratch Code ist nun aus der Datei /var/tokens/google/g0001 verschwunden
 cat /var/tokens/google/g0001
```

### Folie 16 L: Testtoken fuer pam_oath erstellen

```
# eine Zeile in /var/tokens/oathtoolkit/users.oath erzeugen
# U000001 mit Prefix 0815
 export secret=$(for i in $(seq 1 40); do echo -n $(echo "obase=16; $(($RANDOM % 16))" | bc); done; echo)
 su -s /bin/bash -c 'echo -e "HOTP/E/6\tU000001\t0815\t${secret}"' radiusd >> /var/tokens/oathtoolkit/users.oath
# check
cat /var/tokens/oathtoolkit/users.oath
# Aktuellen Wert fuer Token aufgrund des Secrets berechnen Zaehler 0
 secret=$(grep '^H.*U000001' /var/tokens/oathtoolkit/users.oath | awk '{print $4}')
 oathtool --hotp -d 6 -c 0 "$secret"
 code=$(oathtool --hotp -d 6 -c 0 "$secret")
 radtest U000001 0815${code} 127.0.0.1 18120 masterblaster2018
```

### Folie 17 FreeRADIUS - Ports in Firewall oeffnen (optional)

```
 firewall-cmd --add-service=radius --zone=public --permanent
 firewall-cmd --reload
 firewall-cmd --list-all
```

### Folie 20 Skripte

Tokenskripte in den richtigen Ordner entpacken

```
 mkdir /usr/local/bin/webmin
 cd /root/clt2019
 tar xzvf centos-radius_librev_final_usr_local_bin_webmin_complete.tar.gz -C /usr/local/bin/webmin
 chmod +x /usr/local/bin/webmin/*token*
```

### Folie 21 - 32 - Erklaerung der Skripte

```
 scratch_token_create
 scratch_token_activate
 scratch_token_scratchadd
 scratch_token_scratchdelete
 scratch_token_deactivate
 scratch_token_delete
 software_token_create
 software_token_activate
 software_token_deactivate
 software_token_delete
 software_token_qrcode
 software_token_lister
```

### Folie 35 Webmin Repository hinzufuegen

### /etc/yum.repos.d/webmin.repo

```
[Webmin]
name=Webmin Distribution Neutral
mirrorlist=https://download.webmin.com/download/yum/mirrorlist
enabled=1
```

```
yum -y update
```

### Folie 36 Webmin Paket installieren

```
# public key jcameron hinzufücd /tmp
 cd /root/ctl2019
 wget http://www.webmin.com/jcameron-key.asc
 rpm --import jcameron-key.asc

# webmin installieren
 yum -y install webmin
```

### Folie 37 Webmin Ports in Firewall oeffnen

```
# Port 10000 tcp
 firewall-cmd --add-port=10000/tcp --zone=public --permanent
 firewall-cmd --reload
```

### Folie 38 Lokalen Linux Benutzer 'otpmanager' erstellen

```
# -c comment
# -m homedir anlegen
# -N no user group
 useradd -c 'Webmin User for OTP administration' -m -N otpmanager
 passwd otpmanager
# Passwort: blo33Action
```

### Folie 39 otpmanager erlauben bestimmte Skripte mit sudo ohne PW auszufuehren

```
visudo
```

```
...
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_activate
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_create
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_deactivate
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_delete
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_scratchadd
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/scratch_token_scratchdelete
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_activate
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_create
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_deactivate
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_delete
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_lister
otpmanager ALL=(ALL) NOPASSWD: /usr/local/bin/webmin/software_token_qrcode
...
```

#### Test

```
 su otpmanager
 cd /usr/local/bin/webmin/
 sudo ./software_token_lister new # sollte ohne Beanstandung mit sudo ausgefuehrt werden
 exit
```

### Folie 40-51 Konfiguration Webmin via Webinterface (siehe Praesentation)

```
# cd /root/clt2019/
# tar xzvf centos-radius_librev_final_etc_webmin_custom_only_html_and_cmd.tar.gz -C /etc/webmin/custom
# mkdir /usr/local/bin/webmin
# tar xzvf centos-radius_librev_final_usr_local_bin_webmin_complete.tar.gz -C /usr/local/bin/webmin

# folgende Dateien wurden schon vorher auf derm Server abgelegt:
/root/clt2019/jcameron-key.asc                                                      # wird fuer Installation von Webmin benoetigt
/root/clt2019/xenlayer-theme.wbt.gz                                                 # Webmin Theme
/root/clt2019/centos-radius_librev_final_usr_local_bin_webmin_complete.tar.gz       # Skripte zur Tokenverwaltung
/root/clt2019/centos-radius_librev_final_etc_webmin_custom_only_html_and_cmd.tar.gz # fertig erstellte custom commands fuer Webmin
```
